#!/bin/bash
#Задаем русскую локаль в системе
#sudo dpkg-reconfigure locales
#Надо перезагрузиться


sudo locale-gen ru_RU.UTF-8
sudo localectl set-locale LANG=ru_RU.UTF-8 LC_TIME=ru_RU.UTF-8 LC_COLLATE=ru_RU.UTF-8

sudo apt install -y gnupg2
sudo apt install curl -y
curl -o pgpro-repo-add.sh https://repo.postgrespro.ru/pg1c-14/keys/pgpro-repo-add.sh
sudo sh pgpro-repo-add.sh
sudo apt-get install postgrespro-1c-14 -y

sudo apt-mark hold postgresql-common postgresql-client-common
sudo apt-mark hold libpq5 postgrespro-1c-14 postgrespro-1c-14-client postgrespro-1c-14-contrib postgrespro-1c-14-libs postgrespro-1c-14-server

systemctl --type=service | grep postgres

# Пример вывода:
#     postgrespro-1c-14.service

# Останавливаем PostgreSQL
sudo systemctl stop postgrespro-1c-14

# Удаляем файлы ранее созданного при установке кластера
# Вместо 1c-14 может быть другое название каталога, в зависимости от версии.
rm -r /var/lib/pgpro/1c-14/data/*

# Инициализируем новый кластер для 1С с нужной локалью (не обязательно, если по умолчанию локаль в системе "ru_RU.UTF-8").
sudo /opt/pgpro/1c-14/bin/pg-setup initdb --tune=1c --locale=ru_RU.UTF-8

# Запускаем PostgreSQL
sudo systemctl start postgrespro-1c-14

#Зададим пароль для пользователя postgres
sudo -u postgres /usr/bin/psql -U postgres -c "alter user postgres with password 'passwordpostgres';"
sudo -u postgres /usr/bin/psql -U postgres -c "CREATE USER sa SUPERUSER PASSWORD 'passwordpostgres';"


#Имеет смысл перенести хранение временной статистики базы данных с жесткого диска в 
#оперативную память (tmpfs ). Это снизит расход ресурса ssd и немного увеличит 
#производительность. Данное действие не костыль и не грязный хак. Подобную рекомендацию 
#можно увидеть в документации для postgres от команды postgresql pro.
sudo mkdir /var/lib/pgpro/stats_temp
sudo chown postgres:postgres /var/lib/pgpro/stats_temp

#Добавляем tmpfs  диск в /etc/fstab.
sudo sed -i '$ a \\ tmpfs /var/lib/pgpro/stats_temp tmpfs size=512M,uid=postgres,gid=postgres 0 0\n' /etc/fstab

#Пробуем подмонтировать этот диск.
sudo mount /var/lib/pgpro/stats_temp

#Проверяем, что получилось:
#sudo df -h | grep stats_temp
#tmpfs           256M     0  512M   0% /var/lib/pgpro/stats_temp

#Всё в порядке, tmpfs диск подключен. Теперь надо изменить параметр в конфигурационном 
#файле postgresql, который отвечает за настройку каталога для хранения временной 
#статистики. Открываем файл /var/lib/pgpro/1c-14/data/postgresql.conf и вносим изменение:

sudo sed -i "$ a \\ stats_temp_directory = '/var/lib/pgpro/stats_temp'\n" /var/lib/pgpro/1c-14/data/postgresql.conf

#stats_temp_directory = '/var/lib/pgpro/stats_temp'

sudo sed -i "$ a \\host    all             all             0.0.0.0/0               password\n" /var/lib/pgpro/1c-14/data/pg_hba.conf

#sudo sed -i "$ a \\listen_addresses = '*'\n" /var/lib/pgpro/1c-14/data/postgresql.conf


#Перезапускаем службу postgrespro-1c-14 для того, чтобы применить изменение.
sudo systemctl restart postgrespro-1c-14

